unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, EncdDecd, FileCtrl;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    Label2: TLabel;
    Button2: TButton;
    Button3: TButton;
    Label3: TLabel;
    Edit1: TEdit;
    Button4: TButton;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Path : string;
  MS   : TMemoryStream;
  MS1  : TMemoryStream;
  LS   : TStringList;
implementation
{$R *.dfm}

function FindCom(S:string; var Tag:string):boolean;
var
 n : integer;
begin
 n := pos(S,Tag);
 if n = 0 then
   begin
    result := true;
    exit;
   end;
 result := false;
 delete(Tag, 1, n + length(s)-1);
end;

function GetCommand(S,Tag:string):string;
var
 n : integer;
begin
 result := '';
 Tag := LowerCase(Tag);
 if FindCom(S, Tag) then exit;
 if FindCom('"', Tag) then exit;

 n := pos('"',Tag);
 if n = 0 then  exit;
 delete(Tag, n, length(Tag)-n+1);
 result := Tag;
end;

procedure OpenFB2(FileName:string);
var
 c : char;
 ss : string;
 i : integer;
 tag  : string;
 Value : string;
 beginTag, AddValue : boolean;
begin
 MS.Clear;   LS.Clear;
 MS.LoadFromFile(FileName);
 
 tag := ''; beginTag := false; AddValue := false;  Value := '';
 MS.Position := 0;
 while MS.Position < MS.Size do
  begin
   MS.Read(c,1);

        case c of
        #10 : ;
        #13 : ;
        '<' : beginTag := true;
        '>' : begin

               ss := '';
               beginTag := false;
               if Tag = '' then continue;
               i := 1;
                 repeat //
                  Ss := Ss + Tag[i];
                  inc(i);
                 until (i > length(Tag)) or (Tag[i] in [' ','>']);

               ss := LowerCase(Ss);

               if ss = 'binary' then
                 begin
              //    if GetCommand('content-type', Tag)= 'arc/zip'
                //   then
                    begin
                     Form1.ListBox1.Items.Add( GetCommand('id', Tag));
                     AddValue := true;
                    end;
                 end;
               if ss = '/binary' then
                 begin
                  LS.Add(Value);
                  AddValue := false;
                 end;

               Value := '';
               Tag := '';

               end;
       else  begin
               if beginTag then
                begin
                 Tag := Tag + c;
                 continue;
                end;
                if AddValue then
                 Value := Value + c;

              end;
        end; // case
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 with OpenDialog1 do
 if Execute then
   begin
    Edit2.Text := FileName;
    OpenFB2(FileName);
   end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Path := ExtractFileDir(ParamStr(0)) + '\';
 MS   := TMemoryStream.Create;
 MS1  := TMemoryStream.Create;
 LS   := TStringList.Create;
 OpenDialog1.InitialDir := Path;
end;

procedure ExtractZIP(n:integer);
var
 S : string;
 i : integer;
begin
 MS.Clear;
 for i := 1 to length(LS[n]) do
  MS.Write(LS[n][i],1);
 MS.Position := 0;
 DecodeStream(MS, MS1);
 MS1.Position := 0;
 with Form1 do
 If Edit1.Text = ''
    then S := Path + ListBox1.Items[n]
    else S := Edit1.Text + '\' + ListBox1.Items[n];
// if not FileExists(S) then
    MS1.SaveToFile(S);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 if ListBox1.ItemIndex = - 1 then exit;
 ExtractZIP(ListBox1.ItemIndex);
 ShowMessage('Done.');
end;

procedure TForm1.Button3Click(Sender: TObject);
var
 Dir : string;
begin
 Dir := Path;
 if SelectDirectory(Dir, [sdAllowCreate, sdPerformCreate, sdPrompt],0)
    then Edit1.Text := Dir;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
 i : integer;
begin
 for i := 0 to ListBox1.Items.Count - 1 do
     ExtractZIP(i);
 ShowMessage('Done.');    
end;

end.
