unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, EncdDecd;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  Path : string;
  MS , MS1    : TMemoryStream;
  LS : TStringList;
implementation

{$R *.dfm}

procedure SaveListAppend(LS : TStringList);
var
 F : TextFile;
 i : integer;
begin
 AssignFile( F, Path+ Form1.Edit1.Text);
 if FileExists( Path+ Form1.Edit1.Text)
   then Append(F)
   else ReWrite(F);
 for i := 0 to LS.Count - 1 do
   writeln(F, LS[i]);
 CloseFile(F);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if Edit1.Text = '' then
   exit;
  with OpenDialog1 do
   if Execute then
    begin
     MS.Clear;  MS1.Clear;
     MS.LoadFromFile(FileName);
     EncodeStream(MS, MS1);
//     Label1.Caption := IntToStr(MS.Size)+'  '+IntToStr(MS1.Size);
     MS1.Position := 0;
     LS.Clear;
     LS.LoadFromStream(MS1);
     LS.Insert(0,'<binary id="'+ExtractFileName(FileName)
                 +'" content-type="arc/zip">');
     LS.Add('</binary>');
     SaveListAppend(LS);
     ShowMessage('Done.');
    end;
       //
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 Path := ExtractFileDir(ParamStr(0)) + '\';
 MS   := TMemoryStream.Create;
 MS1  := TMemoryStream.Create;
 LS   := TStringList.Create;
 OpenDialog1.InitialDir := Path;
end;

end.
